import org.apache.hc.client5.http.classic.methods.HttpGet;
import org.apache.hc.client5.http.config.RequestConfig;
import org.apache.hc.client5.http.impl.classic.CloseableHttpClient;
import org.apache.hc.client5.http.impl.classic.CloseableHttpResponse;
import org.apache.hc.client5.http.impl.classic.HttpClientBuilder;
import org.apache.hc.core5.http.HttpEntity;
import org.apache.hc.core5.http.HttpHost;
import org.apache.hc.core5.http.ParseException;
import org.apache.hc.core5.http.io.entity.EntityUtils;

import java.io.IOException;
import java.nio.charset.StandardCharsets;

/**
 * Create by ipidea on 2021/2/6
 * <p>
 * 依赖 compile 'org.apache.httpcomponents.client5:httpclient5:5.0.3'
 *
 * @see <a href="http://hc.apache.org/httpcomponents-client-5.0.x/httpclient5/dependency-info.html">httpcomponents</a>
 */
class HttpProxy {
    public static void httpProxy() {
        HttpGet request = new HttpGet("http://ky.myip.top/");
        RequestConfig requestConfig = RequestConfig.custom()
                .setProxy(new HttpHost("221.229.173.99", 13001))
                .build();
        request.setConfig(requestConfig);

        try {
            CloseableHttpClient httpClient = HttpClientBuilder.create()
                    .disableRedirectHandling()
                    .build();
            CloseableHttpResponse response = httpClient.execute(request);

            // Get HttpResponse Status
            System.out.println(response.getVersion());
            System.out.println(response.getCode());
            System.out.println(response.getReasonPhrase());

            HttpEntity entity = response.getEntity();
            if (entity != null) {
                // return it as a String
                String result = EntityUtils.toString(entity, StandardCharsets.UTF_8);
                System.out.println(result);
            }

        } catch (ParseException | IOException e) {
            e.printStackTrace();
        }
    }


    public static void main(String[] args) {
        httpProxy();
    }
}
